# Lean

The lean web optimized for security, privacy and usability in dark nets.

## What is this?

This is the umbrella project that contains all projects:

* A lean web browser
* A lean server
* Libraries and tools for developers and website admins
* Specifications for the lean web

## FAQ

TODO

## Package Status

Legend:
From least amount of completion to completed:

NOT_STARTED - Nothing done yet.
PLANNING    - In the planning phase, idea collection, etc.
WIP         - Actively working on this
STAGING     - Almost finished, needs some touching up
DONE        - Completed (usable for the intended purpose)

* ldsf                - STAGING
* ldsf-lean           - WIP
* lai                 - STAGING
* larp                - WIP
* lean-server         - PLANNING
* lean                - PLANNING / WIP
* lean-handler-text   - STAGING
* lean-handler-search - PLANING
* lean-handler-video  - NOT_STARTED
* lean-handler-image  - NOT_STARTED
* lean-handler-blog   - NOT_STARTED
* lean-handler-forum  - NOT_STARTED
...

## Building

To build the projects you will require a relatively recent version of
GHC and cabal.

In this directory you can then type:

`cabal new-build all`

to build all packages.

Alternatively you can build a specific package, like the browser and
category handlers:

`cabal new-build lean lean-handler-text`

TODO: build release packages

## Test Coverage

* ldsf               - done
* ldsf-lean          - untested
* lai                - untested
* larp               - untested
* lean-server        - untested
* lean               - untested
* lean-handler-text  - untested
....

## TODO

This is largely just for reference and will likely be incomplete.

* Make specifications stable
* Set cabal version ranges in each package
* Look over all TODOs in the code base and implement them
* Look over all FIXMEs and fix them
* write property tests for _everything_
* Extend "Contributing" once everything is stable

## Contributing

I'd recommend _against_ contributing or building against this until the
specifications have been made stable. Things _will_ break and they _will_
change. **Zero** guarantees are given for any kind of stability this early
in the development cycle.

Feedback on the browser and usability itself and the underlying specifications
is highly appreciated.

## Licensing

Packages are either released under GPLv3, AGPLv3 or BSD3 license.

Generally packages are licensed with the following logic:

Libraries:                      BSD3
Programs which run server-side: AGPLv3
Programs which the users run:   GPLv3

Make sure to check each package. When in doubt, just ask.

## Contact

crowbar@mail.i2p
